<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckUserRequest StructType
 * Meta informations extracted from the WSDL
 * - type: CheckUserRequest
 * @subpackage Structs
 */
class CheckUserRequest extends REQUEST
{
    /**
     * The USER
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\GIBUSER
     */
    public $USER;
    /**
     * The DOCUMENT_TYPE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DOCUMENT_TYPE;
    /**
     * Constructor method for CheckUserRequest
     * @uses CheckUserRequest::setUSER()
     * @uses CheckUserRequest::setDOCUMENT_TYPE()
     * @param \StructType\GIBUSER $uSER
     * @param string $dOCUMENT_TYPE
     */
    public function __construct(\StructType\GIBUSER $uSER = null, $dOCUMENT_TYPE = null)
    {
        $this
            ->setUSER($uSER)
            ->setDOCUMENT_TYPE($dOCUMENT_TYPE);
    }
    /**
     * Get USER value
     * @return \StructType\GIBUSER
     */
    public function getUSER()
    {
        return $this->USER;
    }
    /**
     * Set USER value
     * @param \StructType\GIBUSER $uSER
     * @return \StructType\CheckUserRequest
     */
    public function setUSER(\StructType\GIBUSER $uSER = null)
    {
        $this->USER = $uSER;
        return $this;
    }
    /**
     * Get DOCUMENT_TYPE value
     * @return string|null
     */
    public function getDOCUMENT_TYPE()
    {
        return $this->DOCUMENT_TYPE;
    }
    /**
     * Set DOCUMENT_TYPE value
     * @param string $dOCUMENT_TYPE
     * @return \StructType\CheckUserRequest
     */
    public function setDOCUMENT_TYPE($dOCUMENT_TYPE = null)
    {
        // validation for constraint: string
        if (!is_null($dOCUMENT_TYPE) && !is_string($dOCUMENT_TYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dOCUMENT_TYPE)), __LINE__);
        }
        $this->DOCUMENT_TYPE = $dOCUMENT_TYPE;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckUserRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
