<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckUserResponse StructType
 * Meta informations extracted from the WSDL
 * - type: CheckUserResponse
 * @subpackage Structs
 */
class CheckUserResponse extends AbstractStructBase
{
    /**
     * The ERROR_TYPE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\REQUEST_ERRORType
     */
    public $ERROR_TYPE;
    /**
     * The USER
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GIBUSER[]
     */
    public $USER;
    /**
     * Constructor method for CheckUserResponse
     * @uses CheckUserResponse::setERROR_TYPE()
     * @uses CheckUserResponse::setUSER()
     * @param \StructType\REQUEST_ERRORType $eRROR_TYPE
     * @param \StructType\GIBUSER[] $uSER
     */
    public function __construct(\StructType\REQUEST_ERRORType $eRROR_TYPE = null, array $uSER = array())
    {
        $this
            ->setERROR_TYPE($eRROR_TYPE)
            ->setUSER($uSER);
    }
    /**
     * Get ERROR_TYPE value
     * @return \StructType\REQUEST_ERRORType|null
     */
    public function getERROR_TYPE()
    {
        return $this->ERROR_TYPE;
    }
    /**
     * Set ERROR_TYPE value
     * @param \StructType\REQUEST_ERRORType $eRROR_TYPE
     * @return \StructType\CheckUserResponse
     */
    public function setERROR_TYPE(\StructType\REQUEST_ERRORType $eRROR_TYPE = null)
    {
        $this->ERROR_TYPE = $eRROR_TYPE;
        return $this;
    }
    /**
     * Get USER value
     * @return \StructType\GIBUSER[]|null
     */
    public function getUSER()
    {
        return $this->USER;
    }
    /**
     * Set USER value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER[] $uSER
     * @return \StructType\CheckUserResponse
     */
    public function setUSER(array $uSER = array())
    {
        foreach ($uSER as $checkUserResponseUSERItem) {
            // validation for constraint: itemType
            if (!$checkUserResponseUSERItem instanceof \StructType\GIBUSER) {
                throw new \InvalidArgumentException(sprintf('The USER property can only contain items of \StructType\GIBUSER, "%s" given', is_object($checkUserResponseUSERItem) ? get_class($checkUserResponseUSERItem) : gettype($checkUserResponseUSERItem)), __LINE__);
            }
        }
        $this->USER = $uSER;
        return $this;
    }
    /**
     * Add item to USER value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER $item
     * @return \StructType\CheckUserResponse
     */
    public function addToUSER(\StructType\GIBUSER $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GIBUSER) {
            throw new \InvalidArgumentException(sprintf('The USER property can only contain items of \StructType\GIBUSER, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->USER[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckUserResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
