<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetGibUserListRequest StructType
 * Meta informations extracted from the WSDL
 * - type: GetGibUserListRequest
 * @subpackage Structs
 */
class GetGibUserListRequest extends REQUEST
{
    /**
     * The TYPE
     * Meta informations extracted from the WSDL
     * - default: XML
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TYPE;
    /**
     * The DOCUMENT_TYPE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DOCUMENT_TYPE;
    /**
     * The REGISTER_TIME_START
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $REGISTER_TIME_START;
    /**
     * Constructor method for GetGibUserListRequest
     * @uses GetGibUserListRequest::setTYPE()
     * @uses GetGibUserListRequest::setDOCUMENT_TYPE()
     * @uses GetGibUserListRequest::setREGISTER_TIME_START()
     * @param string $tYPE
     * @param string $dOCUMENT_TYPE
     * @param string $rEGISTER_TIME_START
     */
    public function __construct($tYPE = 'XML', $dOCUMENT_TYPE = null, $rEGISTER_TIME_START = null)
    {
        $this
            ->setTYPE($tYPE)
            ->setDOCUMENT_TYPE($dOCUMENT_TYPE)
            ->setREGISTER_TIME_START($rEGISTER_TIME_START);
    }
    /**
     * Get TYPE value
     * @return string|null
     */
    public function getTYPE()
    {
        return $this->TYPE;
    }
    /**
     * Set TYPE value
     * @uses \EnumType\TYPE::valueIsValid()
     * @uses \EnumType\TYPE::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tYPE
     * @return \StructType\GetGibUserListRequest
     */
    public function setTYPE($tYPE = 'XML')
    {
        // validation for constraint: enumeration
        if (!\EnumType\TYPE::valueIsValid($tYPE)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $tYPE, implode(', ', \EnumType\TYPE::getValidValues())), __LINE__);
        }
        $this->TYPE = $tYPE;
        return $this;
    }
    /**
     * Get DOCUMENT_TYPE value
     * @return string|null
     */
    public function getDOCUMENT_TYPE()
    {
        return $this->DOCUMENT_TYPE;
    }
    /**
     * Set DOCUMENT_TYPE value
     * @param string $dOCUMENT_TYPE
     * @return \StructType\GetGibUserListRequest
     */
    public function setDOCUMENT_TYPE($dOCUMENT_TYPE = null)
    {
        // validation for constraint: string
        if (!is_null($dOCUMENT_TYPE) && !is_string($dOCUMENT_TYPE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dOCUMENT_TYPE)), __LINE__);
        }
        $this->DOCUMENT_TYPE = $dOCUMENT_TYPE;
        return $this;
    }
    /**
     * Get REGISTER_TIME_START value
     * @return string|null
     */
    public function getREGISTER_TIME_START()
    {
        return $this->REGISTER_TIME_START;
    }
    /**
     * Set REGISTER_TIME_START value
     * @param string $rEGISTER_TIME_START
     * @return \StructType\GetGibUserListRequest
     */
    public function setREGISTER_TIME_START($rEGISTER_TIME_START = null)
    {
        // validation for constraint: string
        if (!is_null($rEGISTER_TIME_START) && !is_string($rEGISTER_TIME_START)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rEGISTER_TIME_START)), __LINE__);
        }
        $this->REGISTER_TIME_START = $rEGISTER_TIME_START;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetGibUserListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
