<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUserAuthorizationRequest StructType
 * Meta informations extracted from the WSDL
 * - type: GetUserAuthorizationRequest
 * @subpackage Structs
 */
class GetUserAuthorizationRequest extends REQUEST
{
    /**
     * The PRODUCT
     * @var string
     */
    public $PRODUCT;
    /**
     * The PRODUCT_DETAIL_FLAG
     * @var string
     */
    public $PRODUCT_DETAIL_FLAG;
    /**
     * Constructor method for GetUserAuthorizationRequest
     * @uses GetUserAuthorizationRequest::setPRODUCT()
     * @uses GetUserAuthorizationRequest::setPRODUCT_DETAIL_FLAG()
     * @param string $pRODUCT
     * @param string $pRODUCT_DETAIL_FLAG
     */
    public function __construct($pRODUCT = null, $pRODUCT_DETAIL_FLAG = null)
    {
        $this
            ->setPRODUCT($pRODUCT)
            ->setPRODUCT_DETAIL_FLAG($pRODUCT_DETAIL_FLAG);
    }
    /**
     * Get PRODUCT value
     * @return string|null
     */
    public function getPRODUCT()
    {
        return $this->PRODUCT;
    }
    /**
     * Set PRODUCT value
     * @uses \EnumType\PRODUCT::valueIsValid()
     * @uses \EnumType\PRODUCT::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $pRODUCT
     * @return \StructType\GetUserAuthorizationRequest
     */
    public function setPRODUCT($pRODUCT = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PRODUCT::valueIsValid($pRODUCT)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $pRODUCT, implode(', ', \EnumType\PRODUCT::getValidValues())), __LINE__);
        }
        $this->PRODUCT = $pRODUCT;
        return $this;
    }
    /**
     * Get PRODUCT_DETAIL_FLAG value
     * @return string|null
     */
    public function getPRODUCT_DETAIL_FLAG()
    {
        return $this->PRODUCT_DETAIL_FLAG;
    }
    /**
     * Set PRODUCT_DETAIL_FLAG value
     * @uses \EnumType\PRODUCT_DETAIL_FLAG::valueIsValid()
     * @uses \EnumType\PRODUCT_DETAIL_FLAG::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $pRODUCT_DETAIL_FLAG
     * @return \StructType\GetUserAuthorizationRequest
     */
    public function setPRODUCT_DETAIL_FLAG($pRODUCT_DETAIL_FLAG = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PRODUCT_DETAIL_FLAG::valueIsValid($pRODUCT_DETAIL_FLAG)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $pRODUCT_DETAIL_FLAG, implode(', ', \EnumType\PRODUCT_DETAIL_FLAG::getValidValues())), __LINE__);
        }
        $this->PRODUCT_DETAIL_FLAG = $pRODUCT_DETAIL_FLAG;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUserAuthorizationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
